--|> CORE
-------------------------------------------------------------------------------
local _, NS = ...

--> DEFAULT CHARACTER OPTIONS
-------------------------------------------------------------------------------
FTL_CHARACTER_OPTIONS =
    FTL_CHARACTER_OPTIONS or
    {
        Enabled = true,
        LDB = {}
    }

--> PRINT ADDON MESSAGE
---------------------------------------
----- @param msg Message
function NS.PrintAddonMessage(msg)
    if not msg then
        return
    end
    (DEFAULT_CHAT_FRAME):AddMessage("|TInterface/Addons/FTL/Media/Icons/chat.tga:0|t  " .. msg)
end

--> ENABLE
---------------------------------------
function NS.Enable()
    FTL_FOCUS_TARGET_FRAME:CheckForAssist()
    FTL_FOCUS_FRAME:Show()
    NS.EnableEvents()
end

--> DISABLE
---------------------------------------
function NS.Disable()
    FTL_FOCUS_TARGET_FRAME:Hide()
    FTL_FOCUS_FRAME:Hide()
    NS.DisableEvents()
end

--> @E ENTERING WORLD
--: Anytime the world is refreshed, such as after taking a portal, hearthing, etc.
---------------------------------------
local Loaded = nil
function NS.EnteringWorld()
    -- Clean frames in case they were not already cleared
    FTL_FOCUS_TARGET_FRAME:Hide()
    FTL_FOCUS_FRAME:Hide()
    -- Run only once on first load
    if not Loaded then
        -- LOAD
        Loaded = true
        NS.PrintAddonMessage("|cffffe153Loaded!|r")

		--
        if FTL_CHARACTER_OPTIONS.Enabled then
            NS.Enable()
        else
            NS.Disable()
        end
    end
end
